import java.lang.*;
import java.io.*;
import java.util.*;
import EDU.neu.ccs.demeter.*;
 class TraceVisitor extends UniversalVisitor {
  protected int indent;
  public int get_indent() { return indent;   }
  public void set_indent(int new_indent) { indent = new_indent;   }
  public TraceVisitor() { super();   }
  public TraceVisitor(int indent) {
    super();
    set_indent(indent);
    }
  
    protected java.io.PrintWriter out = new java.io.PrintWriter(System.out, true);
    java.io.PrintWriter get_out()             { return out; }
    void set_out(java.io.PrintWriter new_out) { out = new_out; }
    TraceVisitor(java.io.PrintWriter out)     { set_out(out); }
    TraceVisitor(java.io.PrintStream out)
      { set_out(new java.io.PrintWriter(out, true)); }
  
  public void finish() { out.flush();   }
  public void before(WebScript host) {
    out.println("before WebScript");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(WebScript host) {
    out.println("after WebScript");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_service_list(WebScript source, Service_List dest) {
    out.println("before -> WebScript, service_list, Service_List ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_service_list(WebScript source, Service_List dest) {
    out.println("after -> WebScript, service_list, Service_List ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Service host) {
    out.println("before Service");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Service host) {
    out.println("after Service");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Url host) {
    out.println("before Url");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Url host) {
    out.println("after Url");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_url(Url source, String dest) {
    out.println("before -> Url, url, String ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_url(Url source, String dest) {
    out.println("after -> Url, url, String ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(TimeOut host) {
    out.println("before TimeOut");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(TimeOut host) {
    out.println("after TimeOut");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_timeout(TimeOut source, float dest) {
    out.println("before -> TimeOut, timeout, float ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_timeout(TimeOut source, float dest) {
    out.println("after -> TimeOut, timeout, float ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_service(TimeOut source, Service dest) {
    out.println("before -> TimeOut, service, Service ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_service(TimeOut source, Service dest) {
    out.println("after -> TimeOut, service, Service ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Repeat host) {
    out.println("before Repeat");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Repeat host) {
    out.println("after Repeat");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_service(Repeat source, Service dest) {
    out.println("before -> Repeat, service, Service ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_service(Repeat source, Service dest) {
    out.println("after -> Repeat, service, Service ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Alternative host) {
    out.println("before Alternative");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Alternative host) {
    out.println("after Alternative");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_main(Alternative source, Service dest) {
    out.println("before -> Alternative, main, Service ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_main(Alternative source, Service dest) {
    out.println("after -> Alternative, main, Service ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_alternate(Alternative source, Service dest) {
    out.println("before -> Alternative, alternate, Service ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_alternate(Alternative source, Service dest) {
    out.println("after -> Alternative, alternate, Service ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Concurrent host) {
    out.println("before Concurrent");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Concurrent host) {
    out.println("after Concurrent");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_service1(Concurrent source, Service dest) {
    out.println("before -> Concurrent, service1, Service ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_service1(Concurrent source, Service dest) {
    out.println("after -> Concurrent, service1, Service ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_service2(Concurrent source, Service dest) {
    out.println("before -> Concurrent, service2, Service ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_service2(Concurrent source, Service dest) {
    out.println("after -> Concurrent, service2, Service ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Main host) {
    out.println("before Main");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Main host) {
    out.println("after Main");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(PrintVisitor host) {
    out.println("before PrintVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(PrintVisitor host) {
    out.println("after PrintVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_indent(PrintVisitor source, int dest) {
    out.println("before -> PrintVisitor, indent, int ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_indent(PrintVisitor source, int dest) {
    out.println("after -> PrintVisitor, indent, int ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_needSpace(PrintVisitor source, boolean dest) {
    out.println("before -> PrintVisitor, needSpace, boolean ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_needSpace(PrintVisitor source, boolean dest) {
    out.println("after -> PrintVisitor, needSpace, boolean ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(CopyVisitor host) {
    out.println("before CopyVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(CopyVisitor host) {
    out.println("after CopyVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_copy(CopyVisitor source, Object dest) {
    out.println("before -> CopyVisitor, copy, Object ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_copy(CopyVisitor source, Object dest) {
    out.println("after -> CopyVisitor, copy, Object ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(SubgraphVisitor host) {
    out.println("before SubgraphVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(SubgraphVisitor host) {
    out.println("after SubgraphVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_is_equal(SubgraphVisitor source, boolean dest) {
    out.println("before -> SubgraphVisitor, is_equal, boolean ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_is_equal(SubgraphVisitor source, boolean dest) {
    out.println("after -> SubgraphVisitor, is_equal, boolean ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(EqualVisitor host) {
    out.println("before EqualVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(EqualVisitor host) {
    out.println("after EqualVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_is_equal(EqualVisitor source, boolean dest) {
    out.println("before -> EqualVisitor, is_equal, boolean ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_is_equal(EqualVisitor source, boolean dest) {
    out.println("after -> EqualVisitor, is_equal, boolean ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(DisplayVisitor host) {
    out.println("before DisplayVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(DisplayVisitor host) {
    out.println("after DisplayVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_indent(DisplayVisitor source, int dest) {
    out.println("before -> DisplayVisitor, indent, int ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_indent(DisplayVisitor source, int dest) {
    out.println("after -> DisplayVisitor, indent, int ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(TraceVisitor host) {
    out.println("before TraceVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(TraceVisitor host) {
    out.println("after TraceVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_indent(TraceVisitor source, int dest) {
    out.println("before -> TraceVisitor, indent, int ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_indent(TraceVisitor source, int dest) {
    out.println("after -> TraceVisitor, indent, int ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(UniversalVisitor host) {
    out.println("before UniversalVisitor");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(UniversalVisitor host) {
    out.println("after UniversalVisitor");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Service_List host) {
    out.println("before Service_List");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Service_List host) {
    out.println("after Service_List");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_first(Service_List source, Nonempty_Service_List dest) {
    out.println("before -> Service_List, first, Nonempty_Service_List ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_first(Service_List source, Nonempty_Service_List dest) {
    out.println("after -> Service_List, first, Nonempty_Service_List ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before(Nonempty_Service_List host) {
    out.println("before Nonempty_Service_List");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after(Nonempty_Service_List host) {
    out.println("after Nonempty_Service_List");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_it(Nonempty_Service_List source, Service dest) {
    out.println("before -> Nonempty_Service_List, it, Service ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_it(Nonempty_Service_List source, Service dest) {
    out.println("after -> Nonempty_Service_List, it, Service ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void before_next(Nonempty_Service_List source, Nonempty_Service_List dest) {
    out.println("before -> Nonempty_Service_List, next, Nonempty_Service_List ");
    indent++;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
  public void after_next(Nonempty_Service_List source, Nonempty_Service_List dest) {
    out.println("after -> Nonempty_Service_List, next, Nonempty_Service_List ");
    indent--;
    for (int i = 0; i < indent; i++) out.print(" ");
    }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
