import java.lang.*;
import java.io.*;
import java.util.*;
import java.net.*;

import EDU.neu.ccs.demeter.*;
 class Url extends Service {
  protected String url;
  public String get_url() { return url;   }
  public void set_url(String new_url) { url = new_url;   }
  public Url() { super();   }
  public Url(String url) {
    super();
    set_url(url);
    }
  public static Url parse(java.io.Reader in) throws ParseException { return new Parser(in)._Url();   }
  public static Url parse(java.io.InputStream in) throws ParseException { return new Parser(in)._Url();   }
  public static Url parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
    }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
    _v_.before(this);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    _v_.after(this);
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    _v_.before_url(this, url);
    _v_.after_url(this, url);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

    void all_WebScript_trv_bef(UniversalVisitor __v0) {
    super.all_WebScript_trv_bef(__v0);
    __v0.before(this);
  }

    void all_WebScript_trv_aft(UniversalVisitor __v0) {
    __v0.after(this);
    super.all_WebScript_trv_aft(__v0);
  }

    void all_WebScript_trv(UniversalVisitor __v0) {
    all_WebScript_trv_bef(__v0);
    __v0.before_url(this, url);
    __v0.after_url(this, url);
    super.all_WebScript_trv(__v0);
    all_WebScript_trv_aft(__v0);
  }


	  // the method that attempts to execute this service
	  public boolean executeService(PrintStream out)
	  {
			// attempt to open the URL and input the
			// output from the url to the out print stream.

			// the new URL reference
			URL newURL = null;
			
			
			try {
				 
				 // create a new url
				 newURL = new URL(get_url());
				 
			} catch (MalformedURLException ex) {
				 System.err.println("Malformed URL: " + get_url());
				 return false;
			}

			// input stream refernce
			InputStream inputFromURL = null;
			
			try {
				 
				 // get the inputstream from the url
				 inputFromURL = newURL.openStream();
				 
			} catch (IOException ex) {
				 System.err.println("Error occured while opening the url: " +
										  get_url());
				 return false;
			}


			// output some info about the url


			// print out the protocol
			out.println("protocol = " + newURL.getProtocol());
			
			// print out the host
			out.println("host = " + newURL.getHost());
			
			// print out the filename
			out.println("filename = " + newURL.getFile());
			
			// print out the port number
			out.println("port = " + newURL.getPort());
			
			// now transfer the input from the url to the
			// print stream.
			
			try {
				 
				 // attempt to read a byte from the instream
				 int readByte = inputFromURL.read();
				 
				 // while we're successful, keep on printing
				 // the byte to the PrintStream
				 while (readByte != -1)
					  {
							out.print((char)readByte);
							readByte = inputFromURL.read();
					  }
				 
			} catch (IOException ex) {
			}
			
			
			// return success
			return true;
			
	  }
	  
}
